package com.example.witsystem_device_plugin.SDK.event;


import android.os.Handler;
import android.util.Log;

import com.alibaba.fastjson.JSON;
import com.witsystem.top.witsystem_android_ble_sdk.WitsystemSDK;
import com.witsystem.top.witsystem_android_ble_sdk.WitsystmBleSDK;
import com.witsystem.top.witsystem_android_ble_sdk.device.manage.DeviceManage;
import com.witsystem.top.witsystem_android_ble_sdk.error.InitErrorCode;
import com.witsystem.top.witsystem_android_ble_sdk.error.NotInitialized;

import java.util.List;

import SDK.model.Devices;
import SDK.service.call.DeviceInfoChange;
import io.flutter.plugin.common.EventChannel;

/**
 * 处理设备信息变化的
 */
public class DeviceChangeHandler implements EventChannel.StreamHandler, DeviceInfoChange<Devices> {


    private EventChannel.EventSink events;

    private DeviceManage deviceManage;

    private final Handler handler = new Handler();

    @Override
    public void onListen(Object arguments, EventChannel.EventSink events) {
        WitsystemSDK witsystemSDK = WitsystmBleSDK.getInstance(null, null, null, null, null);
        if (witsystemSDK == null) {
            handler.post(() -> events.error(String.valueOf(InitErrorCode.NOT_INITIALIZED.getCode()), InitErrorCode.NOT_INITIALIZED.getError(), JSON.toJSONString(new NotInitialized())));
            return;
        }
        this.events = events;
        deviceManage = witsystemSDK.getDeviceManage();
        deviceManage.getDeviceService().addObserver(this);
    }

    @Override
    public void onCancel(Object arguments) {
        if (deviceManage.getDeviceService() != null) {
            deviceManage.getDeviceService().removeObserver(this);
        }
        events.endOfStream();
    }

    @Override
    public void change(List list) {
        if (events != null)
            handler.post(() -> events.success(list == null ? "[]" : JSON.toJSONString(list)));
    }
}
